from asset_discovery.repository.path_resolver import PathResolver
from asset_discovery.repository.settings_provider import BaseSettingsProvider
from asset_discovery.environment import Environment


class SettingsProvider(BaseSettingsProvider):
    NI_INSTALLERS_REG_PATH = 'SOFTWARE\\National Instruments\\Common\\Installer'
    NI_INSTALLERS_REG_KEY_APP_DATA = 'NIPUBAPPDATADIR'

    DATA_DIRECTORY = 'Data'
    ASSETS_DIRECTORY = 'Assets'
    CACHE_DIRECTORY = 'Cache'
    MERGED_CACHE_DIRECTORY = 'merged'

    def get_store_directory_path(self):
        if Environment.DEBUG_MODE:
            return Environment.DEBUG_JSON_PATH
        return PathResolver.get_joined_skyline_appdata_dir(
            SettingsProvider.DATA_DIRECTORY,
            SettingsProvider.ASSETS_DIRECTORY,
            SettingsProvider.CACHE_DIRECTORY)

    def get_merged_store_directory_path(self):
        if Environment.DEBUG_MODE:
            return Environment.DEBUG_JSON_PATH
        return PathResolver.get_joined_skyline_appdata_dir(
            SettingsProvider.DATA_DIRECTORY,
            SettingsProvider.ASSETS_DIRECTORY,
            SettingsProvider.CACHE_DIRECTORY,
            SettingsProvider.MERGED_CACHE_DIRECTORY)
