from abc import ABC, abstractmethod


class BagProvider(ABC):
    @abstractmethod
    def get_all(self):
        raise NotImplementedError

    @abstractmethod
    def get_unsafe(self, requested_bags):
        raise NotImplementedError

    @abstractmethod
    def create(self, bag):
        raise NotImplementedError

    @abstractmethod
    def update(self, bag):
        raise NotImplementedError

    @abstractmethod
    def remove(self, resource_uri: str, mode: int):
        raise NotImplementedError

    @abstractmethod
    def self_test(self, bag, mode):
        raise NotImplementedError

    @abstractmethod
    def self_calibrate(self, bag):
        raise NotImplementedError

    @abstractmethod
    def self_reset(self, bag, mode):
        raise NotImplementedError

    @abstractmethod
    def any_properties_changed(self):
        raise NotImplementedError
