from abc import ABC, abstractmethod


class DataStore(ABC):
    def __init__(self, json_provider):
        self._json_provider = json_provider

    @abstractmethod
    def list(self):
        pass

    @abstractmethod
    def get_identification_to_entry(self):
        pass

    @abstractmethod
    def add(self, entry):
        pass

    @abstractmethod
    def remove(self, identification):
        pass

    @abstractmethod
    def remove_all(self):
        pass

    @abstractmethod
    def update(self, update_data, source_props_only=False):
        pass
