import os

from asset_discovery.repository.json_provider_factory import DataProviderFactory
from asset_discovery.repository.file_json_provider import FileJsonProvider


class FileJsonProviderFactory(DataProviderFactory):
    def create_data_provider(self, settings_provider=None, **kwargs):
        store_directory_path = settings_provider.get_store_directory_path()
        extra_paths = kwargs.get("extra_paths", [])
        if extra_paths:
            store_directory_path = os.path.join(store_directory_path, *extra_paths)
        return FileJsonProvider(store_directory_path)
