from abc import ABC, abstractmethod


class DataProvider(ABC):
    @abstractmethod
    def get_all(self):
        raise NotImplementedError

    @abstractmethod
    def create(self, json_data):
        raise NotImplementedError

    @abstractmethod
    def replace(self, json_data):
        raise NotImplementedError

    @abstractmethod
    def remove(self, json_uri):
        raise NotImplementedError

    @abstractmethod
    def get_qualified_uri(self, base_uri):
        raise NotImplementedError
