class ObjectPatcher:
    @staticmethod
    def patch(object_to_update, update_data, source_props_only=False, default=None):
        update_props = ObjectPatcher._get_non_default_properties(update_data.__dict__, default)
        if source_props_only:
            source_props = ObjectPatcher._get_non_default_properties(object_to_update.__dict__, None)
            update_props = {k: update_props.get(k, v) for k, v in source_props.items()}
        object_to_update.__dict__.update(update_props)
        return object_to_update

    @staticmethod
    def _get_non_default_properties(source_dict, default):
        return {k: v for k, v in source_dict.items() if v is not default}
