from abc import ABC, abstractmethod


class PluginManagerBase(ABC):
    @property
    @abstractmethod
    def plugins(self):
        pass

    @abstractmethod
    def get_sorted_plugins(self, high_to_low=True, min_weight=0.0):
        pass

    @abstractmethod
    def get_plugin_by_id(self, plugin_id):
        pass
